FilterMapper (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.mappers, class: FilterMapper

# Class FilterMapper

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.FilterChain
org.apache.tools.ant.types.mappers.FilterMapper

All Implemented Interfaces:
  `Cloneable, FileNameMapper`

public class FilterMapper extends FilterChain implements FileNameMapper
This is a FileNameMapper based on a FilterChain.

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FilterMapper()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String[]`
  `mapFileName(String sourceFileName)`
  Return the result of the filters on the sourcefilename.
  `void`
  `setFrom(String from)`
  From attribute not supported.
  `void`
  `setTo(String to)`
  From attribute not supported.

  ### Methods inherited from class FilterChain

  `add, addClassConstants, addContainsRegex, addDeleteCharacters, addEscapeUnicode, addExpandProperties, addFilterReader, addHeadFilter, addIgnoreBlank, addLineContains, addLineContainsRegExp, addPrefixLines, addReplaceRegex, addReplaceString, addReplaceTokens, addStripJavaComments, addStripLineBreaks, addStripLineComments, addSuffixLines, addTabsToSpaces, addTailFilter, addTokenFilter, addTrim, dieOnCircularReference, getFilterReaders, setRefid`
  Modifier and Type
  Method
  Description
  `void`
  `add(ChainableReader filter)`
  Add a chainfilter filter.
  `void`
  `addClassConstants(ClassConstants classConstants)`
  Add a ClassConstants filter.
  `void`
  `addContainsRegex(TokenFilter.ContainsRegex filter)`
  Add a containsregex filter.
  `void`
  `addDeleteCharacters(TokenFilter.DeleteCharacters filter)`
  Add a delete characters filter.
  `void`
  `addEscapeUnicode(EscapeUnicode escapeUnicode)`
  Add an EscapeUnicode filter.
  `void`
  `addExpandProperties(ExpandProperties expandProperties)`
  Add an ExpandProperties filter.
  `void`
  `addFilterReader(AntFilterReader filterReader)`
  Add an AntFilterReader filter.
  `void`
  `addHeadFilter(HeadFilter headFilter)`
  Add a HeadFilter filter.
  `void`
  `addIgnoreBlank(TokenFilter.IgnoreBlank filter)`
  Add an ignoreBlank filter.
  `void`
  `addLineContains(LineContains lineContains)`
  Add a LineContains filter.
  `void`
  `addLineContainsRegExp(LineContainsRegExp lineContainsRegExp)`
  Add a LineContainsRegExp filter.
  `void`
  `addPrefixLines(PrefixLines prefixLines)`
  Add a PrefixLines filter.
  `void`
  `addReplaceRegex(TokenFilter.ReplaceRegex filter)`
  Add a replaceregex filter.
  `void`
  `addReplaceString(TokenFilter.ReplaceString filter)`
  Add a replacestring filter.
  `void`
  `addReplaceTokens(ReplaceTokens replaceTokens)`
  Add a ReplaceTokens filter.
  `void`
  `addStripJavaComments(StripJavaComments stripJavaComments)`
  Add a StripJavaCommands filter.
  `void`
  `addStripLineBreaks(StripLineBreaks stripLineBreaks)`
  Add a StripLineBreaks filter.
  `void`
  `addStripLineComments(StripLineComments stripLineComments)`
  Add a StripLineComments filter.
  `void`
  `addSuffixLines(SuffixLines suffixLines)`
  Add a SuffixLines filter.
  `void`
  `addTabsToSpaces(TabsToSpaces tabsToSpaces)`
  Add a TabsToSpaces filter.
  `void`
  `addTailFilter(TailFilter tailFilter)`
  Add a TailFilter filter.
  `void`
  `addTokenFilter(TokenFilter tokenFilter)`
  Add a TokenFilter filter.
  `void`
  `addTrim(TokenFilter.Trim filter)`
  Add a trim filter.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `Vector<Object>`
  `getFilterReaders()`
  Return the filters.
  `void`
  `setRefid(Reference r)`
  Makes this instance in effect a reference to another FilterChain instance.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### FilterMapper

    public FilterMapper()

- ## Method Details

  - ### setFrom

    public void setFrom(String from)
    From attribute not supported.
    Specified by:
      `setFrom` in interface `FileNameMapper`
    Parameters:
      `from` - a string
    Throws:
      `BuildException` - always

  - ### setTo

    public void setTo(String to)
    From attribute not supported.
    Specified by:
      `setTo` in interface `FileNameMapper`
    Parameters:
      `to` - a string
    Throws:
      `BuildException` - always

  - ### mapFileName

    public String[] mapFileName(String sourceFileName)
    Return the result of the filters on the sourcefilename.
    Specified by:
      `mapFileName` in interface `FileNameMapper`
    Parameters:
      `sourceFileName` - the filename to map
    Returns:
      a one-element array of converted filenames, or null if the filterchain returns an empty string.